﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.ServiceModel.Syndication;

namespace NerdDinner.Controllers
{

    [HandleErrorWithELMAH]
    public class HomeController : AsyncController
    {

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult About()
        {
            return View();
        }

        public ActionResult PrivacyPolicy()
        {
            return View();
        }

        // http://www.wintellect.com/CS/blogs/jprosise/archive/2010/03/29/asynchronous-controllers-in-asp-net-mvc-2.aspx
        public ActionResult News()
        {
            RssFeed feed = new RssFeed();
            IEnumerable<SyndicationItem> items =
                feed.GetRssFeed("http://feeds.abcnews.com/abcnews/topstories"); // blocking call

            ViewData["SyndicationItems"] = items;
            return View();
        }

        public void FastNewsAsync()
        {
            AsyncManager.OutstandingOperations.Increment();
            RssFeed feed = new RssFeed();
            feed.GetRssFeedAsyncCompleted += (s, e) =>
            {
                AsyncManager.Parameters["items"] = e.Items;
                AsyncManager.OutstandingOperations.Decrement();
            };
            feed.GetRssFeedAsync("http://feeds.abcnews.com/abcnews/topstories"); //  not calling GetRssFeed
        }

        public ActionResult FastNewsCompleted(IEnumerable<SyndicationItem> items)
        {
            ViewData["SyndicationItems"] = items;
            return View();
        }












        //[ChildActionOnly]
        //public ActionResult TotalDinners()
        //{
        //    return PartialView();
        //}
    }
}
